<!--
 * @Descripttion: (商品类目/tb_goods_category 添加弹窗)
 * @version: (1.0)
 * @Author: (lwh)
 * @Date: (2023-06-12)
 * @LastEditors: (lwh)
 * @LastEditTime: (2023-06-12)
-->
<template>
  <el-dialog v-model="props.modelValue" title="添加商品类目信息" width="700px" @closed="closeDialog" @open="openDialog">
    <el-form ref="formRef" :model="formData" :rules="rules">

      <el-row>
        <el-col :lg="24">
          <el-form-item :label-width="labelWidth" label="上级菜单" prop="GoodsCategoryParentGuid">
            <el-cascader class="w100" :options="dataList"
              :props="{ checkStrictly: true, value: 'goodsCategoryGuid', label: 'goodsCategoryName', emitPath: false }"
              placeholder="请选择上级菜单" clearable v-model="formData.goodsCategoryParentGuid">
              <template #default="{ node, data }">
                <span>{{ data.goodsCategoryName }}</span>
                <span v-if="!node.isLeaf"> ({{ data.children.length }}) </span>
              </template>
            </el-cascader>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row :gutter="20">

        <el-col :lg="12">
          <el-form-item :label-width="labelWidth" label="名称" prop="goodsCategoryName">
            <el-input v-model="formData.goodsCategoryName" placeholder="请输入名称" />
          </el-form-item>
        </el-col>
        <el-col :lg="24">
          <el-form-item :label-width="labelWidth" label="图片" prop="goodsCategoryImg">
            <UploadImage ref="uploadRef" v-model="formData.goodsCategoryImg" :data=imgData :limit="1" :fileSize="5"
              :drag="true" />
          </el-form-item>
        </el-col>
        <el-col :lg="12">
          <el-form-item :label-width="labelWidth" label="显示状态" prop="goodsCategoryDisplayStatus">
            <el-radio-group v-model="formData.goodsCategoryDisplayStatus">
              <el-radio v-for="item in  display_status " :key="item.dictValue"
                :label="parseInt(item.dictValue)">{{ item.dictLabel }}</el-radio>
            </el-radio-group>
          </el-form-item>
        </el-col>
        <el-col :lg="12">
          <el-form-item :label-width="labelWidth" label="是否为热门" prop="goodsCategoryIsPopular">
            <el-radio-group v-model="formData.goodsCategoryIsPopular">
              <el-radio v-for="item in  is_popular " :key="item.dictValue"
                :label="parseInt(item.dictValue)">{{ item.dictLabel }}</el-radio>
            </el-radio-group>
          </el-form-item>
        </el-col>
        <el-col :lg="12">
          <el-form-item :label-width="labelWidth" label="排序" prop="productCategorySort">
            <el-input-number v-model.number="formData.productCategorySort" controls-position="right" :min="0" />
          </el-form-item>
        </el-col>

      </el-row>
    </el-form>

    <template #footer>
      <div key="dialog-footer">
        <el-button type="primary" @click="handleAddClick(formRef)">添加</el-button>
        <el-button @click="handleResetClick(formRef)">重置</el-button>
      </div>
    </template>
  </el-dialog>
</template>


<script setup>
import { reactive, ref, watch } from "vue";
import { ElMessage } from 'element-plus'
import modal from '@/plugins/modal.js'
import { goodsCategoryTreeList, addOrUpdateGoodsCategory } from '@/api/business/GoodsManager/GoodsCategorys/goodsCategory.js';


// 打开弹窗时回调
const openDialog = async () => {

  await getdisplay_status()
  await getis_popular()

  await getTreeList()
}

// -业务参数
const dataList = ref([])
// 显示状态字典选项列表
const display_status = ref([]);
// 是否为热门字典选项列表
const is_popular = ref([]);


// -业务方法
// 字典获取
async function getdisplay_status() {
  await proxy.getDicts('display_status').then((res) => {
    display_status.value = res.data
  })
}
// 字典获取
async function getis_popular() {
  await proxy.getDicts('is_popular').then((res) => {
    is_popular.value = res.data
  })
}



// -基础参数
const labelWidth = 100;
const formRef = ref();
const { proxy } = getCurrentInstance()
const emits = defineEmits(["update:modelValue"]);
const formData = reactive({
  goodsCategoryDisplayStatus: 1,
  goodsCategoryIsPopular: 0,
  productCategorySort: 100
});
const props = defineProps({
  modelValue: Boolean,
  done: Function,
});
const imgData = ref({
  fileDir: "GoodsCategory"
})

// 验证
const rules = reactive({
  goodsCategoryParentGuid: [{ required: true, message: "上级菜单不能为空", trigger: "blur", type: "number" }],
  goodsCategoryName: [{ required: true, message: "名称不能为空", trigger: "blur" }],
  goodsCategoryDisplayStatus: [{ required: true, message: "显示状态不能为空", trigger: "blur", type: "number" }],
  productCategorySort: [{ required: true, message: "排序不能为空", trigger: "blur", type: "number" }],
});

// -基础方法
async function getTreeList() {
  goodsCategoryTreeList().then((res) => {
    if (res.code == 200) {
      dataList.value = res.data
    }
  })
}
watch(props, async (v) => {

});

// 提交
const handleAddClick = async (formEl) => {
  if (!formEl) return;
  formEl.validate(async (valid) => {
    if (!valid) {
      return;
    }


    const { code } = await addOrUpdateGoodsCategory(formData);
    if (code == 200) {
      modal.msgSuccess('添加成功')
      closeDialog();
    }
  });
};
const closeDialog = () => {
  handleResetClick(formRef.value);
  props.done();
  emits("update:modelValue", false);
};
const handleResetClick = async (formEl) => {
  if (!formEl) return;
  formEl.resetFields();
};
</script>